'use strict';
const e = React.createElement;


var noteMessageFlag = false;

const groupBy = (xs, key) =>  {
    return xs.reduce(function(rv, x) {
      (rv[x[key]] = rv[x[key]] || []).push(x);
      return rv;
    }, {});
};
let tagText = null;

const handleKeypress = e => {
  if (e.charCode === 13) {
    e.preventDefault();
  }
};

// Filter Component that is used to perform search
const Filter = (props) => {
  // $("#country-filter").on("keypress", function(e) {
  //   if (e.which === 32 && !this.value.length)
  //   e.preventDefault();
  // });
    return (
        <div className="filter-section row">
            <div className="col-12 col-md-4 no-outline">
                {/* <div className="label mb-1">Filter Countries</div> */}
                <form action="none" className="filter-box">
                    <input type="text" value={props.searchTerm} onKeyPress={handleKeypress} onChange={(e) => { window.scrollTo(0, $('.pricing-content').position().top - 180); props.setSearchTerm(e.target.value) }} placeholder="Filter Countries" id="country-filter" />
                    {props.searchTerm &&
                        <span className="close-icon" onClick={() => { props.setSearchTerm('')}}><img src="/assets/images/icons/status-page/ic-clear-all.svg" alt="Clear" /></span>
                    }
                </form>
            </div>
            <div className="col-12 col-md-8 d-sm-flex align-items-center d-none alphabet-list-holder">
                <div className="alphabet-list">
                    {prepareAlphabets(props.groupedCountries)}
                </div>
            </div>
        </div>
    )
}

// Create Alphabets Filter
const prepareAlphabets = (groupedCountries) => {
    let result = [];
    const availableChars = Object.keys(groupedCountries);
    for (let i = 65; i < 91; i++) {
        const char = String.fromCharCode(i);
        result.push(
            <a key={i} className={'each-alph alphabet alpha-' + char + ' ' + (availableChars.includes(char) ? '' : 'not-available')} href={"#country-" + char}>{char}</a>
        )
    }
    return result;
}

// Intersection Observer for the letters
const obs = new IntersectionObserver((entries) => {
    entries.forEach(e => {
        if (e.isIntersecting) {
            $('.country-active').removeClass('country-active');
            if( e.target.className.includes('country') ) {
                var countryAlp = e.target.className.split('country-anchor-');
                var alpha = countryAlp[1];
                 $('.show-table [href="#country-'+ alpha +'"]').addClass('country-active');
            }
        }
    })
}, { rootMargin: '0px 0px -200px 0px' })


const loopEachRow = ( groupedByTags ) => {
    // console.log(groupedByTags);
     return groupedByTags.map((type) => {
         // To determine wether to show message or not
         (parseFloat(type.rate) === 0 || parseFloat(type.messagingRate) === 0) && (noteMessageFlag = true);

        return (
          <div className="each-row-value"> 
               <div className={"sms-mms-header row no-gutters  " + ( type.mmsRate ? "": "d-none")}  >
                    <div className="col-6 col-xs-7"></div>
                    <div className="col price receive-call"> </div>
                    <div className="col price receive-msg"> 
                        <div className={"p-0 " + ( type.mmsRate ? "col-6": "")}> SMS  </div>
                        <div className="p-0 col-6">MMS </div>
                    </div> 
                    <div className="col price" > </div>
                </div>
              <div className="row no-gutters">
                    <div className="col-6 col-xs-7">{type.type}</div>
                    <div className={"col price receive-call" + (type.rate ? "" : " na")}><span className="only-m m-header">Receive Calls : </span> {type.rate ? '$' +(parseFloat(type.rate).toFixed(4) + "" + (parseFloat(type.rate) === 0 ? '*' : '')) : 'NA'}</div>
                    
                    <div className="col price receive-msg"> 
                        <div className={"p-0 " + ( type.mmsRate ? "col-6": "")}>
                            <span className="only-m m-header">Receive SMS : </span>{type.messagingRate == 'NA' || type.messagingRate == '' ? type.messagingRate : `$${parseFloat(type.messagingRate).toFixed(4)}` } 
                        </div>
                        <div className={"col-6 p-0 " + ( type.mmsRate ? "": "d-none")} >
                            <span className="only-m m-header">Receive MMS : </span>{ `$${parseFloat(type.mmsRate).toFixed(4)}` } 
                        </div>
                    </div> 
                    <div className={"col price" + (type.rentalRate ? "" : " na")}><span className="only-m m-header">Rental : </span>
                         {type.rentalRate ? `$${parseFloat(type.rentalRate).toFixed(4)}` : "NA"} 
                        {type.setupPrice ?  <span className="small-note">Setup-price ${parseFloat(type.setupPrice).toFixed(4)} </span> : ''}
                    </div>
                </div>
          </div>
        );
      });
}
const loopByCountry = (  ) => {
    // console.log(groupedByTags);
     return groupedByTags.map((type) => {
         // To determine wether to show message or not
         (parseFloat(type.rate) === 0 || parseFloat(type.messagingRate) === 0) && (noteMessageFlag = true);

        return (
          <div className="each-row-value"> 
               <div className={"sms-mms-header row no-gutters  " + ( type.mmsRate ? "": "d-none")}  >
                    <div className="col-6 col-xs-7"></div>
                    <div className="col price receive-call"> </div>
                    <div className="col price receive-msg"> 
                        <div className={"p-0 " + ( type.mmsRate ? "col-6": "")}> SMS  </div>
                        <div className="p-0 col-6">MMS </div>
                    </div> 
                    <div className="col price" > </div>
                </div>
              <div className="row no-gutters">
                    <div className="col-6 col-xs-7">{type.type}</div>
                    <div className={"col price receive-call" + (type.rate ? "" : " na")}><span className="only-m m-header">Receive Calls : </span> {type.rate ? '$' +(parseFloat(type.rate).toFixed(4) + "" + (parseFloat(type.rate) === 0 ? '*' : '')) : 'NA'}</div>
                    
                    <div className="col price receive-msg"> 
                        <div className={"p-0 " + ( type.mmsRate ? "col-6": "")}>
                            <span className="only-m m-header">Receive SMS : </span>{type.messagingRate == 'NA' || type.messagingRate == '' ? type.messagingRate : `$${parseFloat(type.messagingRate).toFixed(4)}` } 
                        </div>
                        <div className={"col-6 p-0 " + ( type.mmsRate ? "": "d-none")} >
                            <span className="only-m m-header">Receive MMS : </span>{ `$${parseFloat(type.mmsRate).toFixed(4)}` } 
                        </div>
                    </div> 
                    <div className={"col price" + (type.rentalRate ? "" : " na")}><span className="only-m m-header">Rental : </span>
                         {type.rentalRate ? `$${parseFloat(type.rentalRate).toFixed(4)}` : "NA"} 
                        {type.setupPrice ?  <span className="small-note">Setup-price ${parseFloat(type.setupPrice).toFixed(4)} </span> : ''}
                    </div>
                </div>
          </div>
        );
      });
}






const loopUsingTags = (groupByTags) => { 
    // console.log(groupByTags);
    let htmlWithTag = [];
    let lengthObj = Object.keys(groupByTags).length;

    for (let keyName of Object.keys(groupByTags)) {
        const groupedByTags = groupByTags[keyName];
        if( lengthObj > 1 ) {
            tagText = (keyName === 'undefined') ?  <div class='tag-label'><div class='row no-gutters tag-label-inner'><span> International Pricing</span></div></div> :   <div class='tag-label'> <div class='row no-gutters tag-label-inner'><span>Domestic Pricing</span></div></div>   ;
        } else {
            tagText = "";
        }
        htmlWithTag.push(tagText, ...loopEachRow( groupedByTags ));
    }

    return htmlWithTag;
}


const makeCallsLoopEachRow = ( groupedByTags ) => {
    // console.log(groupedByTags);
    return groupedByTags.map((type) => {
        // To determine wether to show message or not
        (parseFloat(type.rate) === 0 || parseFloat(type.messagingRate) === 0) && (noteMessageFlag = true);

       return (
         <div> 
             <div className="row no-gutters">
                   <div className="col-6 col-xs-7">{type.type}</div>
                   <div className={"col price" + (type.rate ? "" : " na")}> <span className="only-m m-header">Make Calls : </span> {type.rate ? '$' +(parseFloat(type.rate).toFixed(4) + "" + (parseFloat(type.rate) === 0 ? '*' : '')) : 'NA'}</div>
               </div>
         </div>
       );
     });
}

const makeCallsLoopUsingTags = (groupByTags) => { 
    // console.log(groupByTags);
   let htmlWithTag = [];
   let lengthObj = Object.keys(groupByTags).length;

   for (let keyName of Object.keys(groupByTags)) {
       const groupedByTags = groupByTags[keyName];
       if( lengthObj > 1 ) {
           tagText = (keyName === 'undefined') ?  <div class='tag-label'><div class='row no-gutters tag-label-inner'><span> International Pricing</span></div></div> :   <div class='tag-label'> <div class='row no-gutters tag-label-inner'><span>Domestic Pricing</span></div></div>   ;
       } else {
           tagText = "";
       }
       htmlWithTag.push(tagText, ...makeCallsLoopEachRow( groupedByTags ));
   }
    // console.log(htmlWithTag);
   return htmlWithTag;
}

const allEqual = arr => arr.every(val=> val.rate === arr[0]['rate']);

const sendMsgLoopEachRow = ( groupedByTags ) => {
    if (allEqual(groupedByTags)) {
        (parseFloat(groupedByTags[0].rate) === 0 || parseFloat(groupedByTags[0].messagingRate) === 0) && (noteMessageFlag = true);
        return (
            <div> 
                <div className="row no-gutters">
                    <div className="col-6 col-xs-7">{groupedByTags[0].type}</div>
                    <div className={"col price" + (groupedByTags[0].rate ? "" : " na")}> <span className="only-m m-header">Send Messages : </span> {groupedByTags[0].rate ? '$' +(parseFloat(groupedByTags[0].rate).toFixed(4) + "" + (parseFloat(groupedByTags[0].rate) === 0 ? '*' : '')) : 'NA'}</div>
                </div>
            </div>
        )
    }
    else {
        return groupedByTags.map((type) => {
            // To determine wether to show message or not
            (parseFloat(type.rate) === 0 || parseFloat(type.messagingRate) === 0) && (noteMessageFlag = true);
    
           return (
             <div> 
                 <div className="row no-gutters">
                       <div className="col-6 col-xs-7">{type.type}</div>
                       <div className={"col price" + (type.rate ? "" : " na")}> <span className="only-m m-header">Send Messages : </span> {type.rate ? '$' +(parseFloat(type.rate).toFixed(4) + "" + (parseFloat(type.rate) === 0 ? '*' : '')) : 'NA'}</div>
                   </div>
             </div>
           );
         });
    }
  
}

const sendMsgLoopUsingTags = ( groupByTags ) => { 
    let htmlWithTag = [];
    let lengthObj = Object.keys(groupByTags).length;
    for (let keyName of Object.keys(groupByTags)) {
        const groupedByTags = groupByTags[keyName];
        if( lengthObj > 1 ) {
            tagText = (keyName === 'undefined') ?  <div class='tag-label'><div class='row no-gutters tag-label-inner'><span> International Pricing</span></div></div> :   <div class='tag-label'> <div class='row no-gutters tag-label-inner'><span>Domestic Pricing</span></div></div>   ;
        } else {
            tagText = "";
        }
        let rows = sendMsgLoopEachRow(groupedByTags);
        if (rows.length > 1) {
            rows = [tagText, ...rows];
        } else {
            rows = [tagText, rows];
        }
        htmlWithTag.push(...rows);
    }
    return htmlWithTag;
 }


// Main Component
const PricingTable = () => {
    const [searchTerm, setSearchTerm] = React.useState('');
    noteMessageFlag = false;

    // Fire after and before component mounts
    React.useEffect(() => {
        document.querySelectorAll('.country').forEach(i => obs.observe(i));
        return () => document.querySelectorAll('.country').forEach(i => obs.unobserve(i));
    })

    // Group countries based on Starting letters
    const groupedCountries = pricingData.filter(i => i.country.toLowerCase().indexOf(searchTerm.toLowerCase().trim()) !== -1).reduce((acc, currentItem) => {
        let index = currentItem.country[0];
        // console.log(currentItem.country);
        if (!acc[index]) acc[index] = { index, countries: [currentItem] }
        else acc[index].countries.push(currentItem);
        var sorted = Object.keys(acc)
        .sort()
        .reduce(function (sorted_acc, key) { 
            sorted_acc[key] = acc[key];
            return sorted_acc;
        }, {});
        return sorted;
    }, {});
    var priorityCountries, priorityCountriesNew = [];
    let countriesToShiftOnTop = ['United States', 'Canada', 'United Kingdom', 'Australia', 'India','France'];

    {Object.values(groupedCountries).map((group, i) => {
        var allCountries = [...group.countries];
        priorityCountries = allCountries.filter(i => countriesToShiftOnTop.includes(i.country));
        Array.prototype.push.apply(priorityCountriesNew, priorityCountries);
    })};

    var result = []

    countriesToShiftOnTop.forEach(function(key) {
        var found = false;
        priorityCountriesNew = priorityCountriesNew.filter(function(item) {
            if(!found && item.country == key) {
                result.push(item);
                found = true;
                return false;
            } else 
                return true;
        })
    })


    priorityCountriesNew = [...result];
    const flagURL = "/assets/images/flags/";

    return (
            <div className="pricing-table show-with-delay">
                <Filter searchTerm={searchTerm} setSearchTerm={setSearchTerm} groupedCountries={groupedCountries}></Filter>
                <div className="pricing-content pt-3">
                    <div className="row no-gutters px-0 header">
                        <h4 className="col-6 col-xs-7 font-weight-bold"></h4>
                        <h4 className="col font-weight-bold receive-call">Receive Calls <br/><span>(USD per min)</span></h4>
                        <h4 className="col font-weight-bold receive-msg"> Receive Messages<br/><span>(USD per message)</span></h4>
                        <h4 className="col font-weight-bold"> Rent Phone Numbers <br/><span>(USD per month)</span></h4>
                    </div>
                    <div>
                        <div className="group" >
                            {priorityCountriesNew.map((country, j) => {
                                const unKnownFlags = {wf: flagURL+"wallis-and-futuna-flag.svg", pm: flagURL+"saint-pierre-and-miquelon-flag.svg", yt: flagURL+"mayotte-flag.svg", nc: flagURL+"new-caledonia-flag.svg", gs: flagURL+"south-korea-flag.svg", gp: flagURL+"guadeloupe-flag.svg" };
                                const flagSrc = unKnownFlags[country.iso.toLowerCase()] || ("https://hatscripts.github.io/circle-flags/flags/" + country.iso.toLowerCase() + ".svg");
                                const groupByTags = groupBy( country.types , 'origin');
                                return (
                                    <div className="country" key={j}>
                                            <div className="sticky row no-gutters">
                                                <div className="country-name col-12 col-xs-7"><img className="flag" src={flagSrc} alt={country.country} style={{ height: 24 }} />{country.country}<span className="country-code">{country.dial}</span></div>
                                                <div className="col receive-call"></div>
                                                <div className="col receive-msg"></div>
                                                <div className="col"></div>
                                            </div>  
                                            {loopUsingTags( groupByTags )}
                                        </div>
                                )
                            })}
                        </div>
                    </div>
                {Object.values(groupedCountries).map((group, i) => {
                    return (
                        <React.Fragment>
                            <div className='anchor ' id={"country-" + group.index}></div>

                            <div className="group"  key={i}>
                                {group.countries.map((country, j) => {
                                    const unKnownFlags = {wf: flagURL+"wallis-and-futuna-flag.svg", pm: flagURL+"saint-pierre-and-miquelon-flag.svg", yt: flagURL+"mayotte-flag.svg", nc: flagURL+"new-caledonia-flag.svg", gs: flagURL+"south-korea-flag.svg", gp: flagURL+"guadeloupe-flag.svg" };
                                    const flagSrc = unKnownFlags[country.iso.toLowerCase()] || ("https://hatscripts.github.io/circle-flags/flags/" + country.iso.toLowerCase() + ".svg");
                                    const groupByTags = groupBy( country.types , 'origin');
                                    return (
                                        <div className={"country country-anchor-"+group.index} key={j}>
                                            <div className="sticky row no-gutters">
                                                <div className="country-name col-12 col-xs-7"><img className="flag" src={flagSrc} alt={country.country} style={{ height: 24 }} />{country.country}<span className="country-code">{country.dial}</span></div>
                                                <div className="col receive-call"></div>
                                                <div className="col receive-msg"></div>
                                                <div className="col"></div>
                                            </div>  
                                            {loopUsingTags( groupByTags )}
                                        </div>
                                    )
                                })}
                            </div>
                        </React.Fragment>
                    )
                })}
                {/* {noteMessageFlag && (
                    <div>
                        <div className="note mt-4 font-14 na">* Rates beyond Fair Usage voice will charged at $0.0120 and messages charged at $0.0200</div>
                    </div>
                )} */}
            </div>
        </div>
    )
}
const WhatsappPricingTable = () => {
    const [searchTerm, setSearchTerm] = React.useState('');
    noteMessageFlag = false;

    // Fire after and before component mounts
    React.useEffect(() => {
        document.querySelectorAll('.country').forEach(i => obs.observe(i));
        return () => document.querySelectorAll('.country').forEach(i => obs.unobserve(i));
    })

    // Group countries based on Starting letters
    const groupedCountries = whatsappPricingData.filter(i => i.country.toLowerCase().indexOf(searchTerm.toLowerCase().trim()) !== -1).reduce((acc, currentItem) => {
        let index = currentItem.country[0];

        if (!acc[index]) acc[index] = { index, countries: [currentItem] }
        else acc[index].countries.push(currentItem);
        var sorted = Object.keys(acc)
        .sort()
        .reduce(function (sorted_acc, key) { 
            sorted_acc[key] = acc[key];
            return sorted_acc;
        }, {});
        return sorted;
    }, {});

    var priorityCountries, priorityCountriesNew = [];
    let countriesToShiftOnTop = ['United States', 'Canada', 'United Kingdom', 'Australia', 'India','France'];

    {Object.values(groupedCountries).map((group, i) => {
        var allCountries = [...group.countries];
        priorityCountries = allCountries.filter(i => countriesToShiftOnTop.includes(i.country));
        Array.prototype.push.apply(priorityCountriesNew, priorityCountries);
    })};

    var result = []

    countriesToShiftOnTop.forEach(function(key) {
        var found = false;
        priorityCountriesNew = priorityCountriesNew.filter(function(item) {
            if(!found && item.country == key) {
                result.push(item);
                found = true;
                return false;
            } else 
                return true;
        })
    })


    priorityCountriesNew = [...result];
    // console.log(priorityCountries);/
    const flagURL = "/assets/images/flags/";

    return (
        <div className="pricing-table show-with-delay">
                <Filter searchTerm={searchTerm} setSearchTerm={setSearchTerm} groupedCountries={groupedCountries}></Filter>
                <div className="pricing-content whatsapp ">
                    <div className="row no-gutters px-0 header">
                        <h4 className="col-4 col-xs-7 font-weight-bold" > Country/Region</h4>
                    <h4 className="col font-weight-bold business-initiated">Business- Initiated Rates <br /><span>(USD per conversation)</span>
                    <span class="info-tooltip  ml-1">
                        <span class="info-icon"></span>
                        <span class="info-tooltiptext">A conversation is a 24-hour window that starts with the initial message.
                        </span>
                    </span> 
                    </h4>
                    <h4 className="col font-weight-bold user-initiated"> User-Initiated Rates<br /><span>(USD per conversation)</span>
                    <span class="info-tooltip ml-1 ">
                        <span class="info-icon"></span>
                        <span class="info-tooltiptext">A conversation is a 24-hour window that starts with the initial message.
                        </span>
                    </span> 
                    </h4>
                    <h4 className="col font-weight-bold"> Platform Fee <br /><span>(USD per conversation)</span>
                    <span class="info-tooltip ml-1">
                        <span class="info-icon"></span>
                        <span class="info-tooltiptext">A conversation is a 24-hour window that starts with the initial message.
                        </span>
                    </span> 
                    </h4>
                    </div>
                   
                {Object.values(groupedCountries).map((group, i) => {
                    return (
                        <React.Fragment>
                            <div className='anchor ' id={"country-" + group.index}></div>

                            <div className="group"  key={i}>
                                {group.countries.map((country, j) => {
                                    const unKnownFlags = {wf: flagURL+"wallis-and-futuna-flag.svg", pm: flagURL+"saint-pierre-and-miquelon-flag.svg", yt: flagURL+"mayotte-flag.svg", nc: flagURL+"new-caledonia-flag.svg", gs: flagURL+"south-korea-flag.svg", gp: flagURL+"guadeloupe-flag.svg" };
                                    const flagSrc = unKnownFlags[country.iso.toLowerCase()] || ("https://hatscripts.github.io/circle-flags/flags/" + country.iso.toLowerCase() + ".svg");
                                    return (
                                        <div className={"country whatsapp-row country-anchor-"+group.index} key={j}>
                                            <div className="row no-gutters">
                                                <div className="country-name col-4 sticky "><img className="flag" src={flagSrc} alt={country.country} style={{ height: 24 }} />{country.country}<span className="country-code">{country.dial}</span></div>

                    
                                                    <div className="col price business-initiated col-xs-7"> <span className="only-m m-header">Business- Initiated Rates <br /><span>(USD per conversation)</span>: </span>  {group['countries'][0].bussinessRate}</div>
                                                    <div className="col price user-initiated col-xs-7"><span className="only-m m-header"> User-Initiated Rates<br /><span>(USD per conversation)</span>: </span> {group['countries'][0].userRate}</div>
                                                    <div className="col price col-xs-7 "><span className="only-m m-header">Platform Fee : </span> {group['countries'][0].platformFee}</div>

                                            </div>  
                                            
                                        </div>
                                    )
                                })}
                            </div>
                        </React.Fragment>
                    )
                })}
            </div>
        </div>
    )
}
const makeCallsPricingTable = () => {
    const [searchTerm, setSearchTerm] = React.useState('');
    noteMessageFlag = false;

    // Fire after and before component mounts
    React.useEffect(() => {
        document.querySelectorAll('.country').forEach(i => obs.observe(i));
        return () => document.querySelectorAll('.country').forEach(i => obs.unobserve(i));
    })

    // Group countries based on Starting letters
    const groupedCountries = makeCallsPricingData.filter(i => i.country.toLowerCase().indexOf(searchTerm.toLowerCase().trim()) !== -1).reduce((acc, currentItem) => {
        let index = currentItem.country[0];
        if (!acc[index]) acc[index] = { index, countries: [currentItem] }
        else acc[index].countries.push(currentItem);
        var sorted = Object.keys(acc)
        .sort()
        .reduce(function (sorted_acc, key) { 
            sorted_acc[key] = acc[key];
            return sorted_acc;
        }, {});
        return sorted;
    }, {});

    var priorityCountries, priorityCountriesNew = [];
    let countriesToShiftOnTop = ['United States', 'Canada', 'United Kingdom', 'Australia', 'India','France'];

    {Object.values(groupedCountries).map((group, i) => {
        var allCountries = [...group.countries];
        priorityCountries = allCountries.filter(i => countriesToShiftOnTop.includes(i.country));
        Array.prototype.push.apply(priorityCountriesNew, priorityCountries);
    })};

    var result = []

    countriesToShiftOnTop.forEach(function(key) {
        var found = false;
        priorityCountriesNew = priorityCountriesNew.filter(function(item) {
            if(!found && item.country == key) {
                result.push(item);
                found = true;
                return false;
            } else 
                return true;
        })
    })


    priorityCountriesNew = [...result];

    const flagURL = "/assets/images/flags/";

    return (
            <div className="pricing-table show-with-delay">
                <Filter searchTerm={searchTerm} setSearchTerm={setSearchTerm} groupedCountries={groupedCountries}></Filter>
                <div className="pricing-content pt-3">
                    <div className="row no-gutters px-0 header">
                        <h4 className="col-6 col-xs-7 font-weight-bold"></h4>
                        <h4 className="col font-weight-bold">Make Calls <br/><span>(USD per min)</span></h4>
                    </div>
                    <div>
                        <div className="group" >
                            {priorityCountriesNew.map((country, j) => {
                                const unKnownFlags = {wf: flagURL+"wallis-and-futuna-flag.svg", pm: flagURL+"saint-pierre-and-miquelon-flag.svg", yt: flagURL+"mayotte-flag.svg", nc: flagURL+"new-caledonia-flag.svg", gs: flagURL+"south-korea-flag.svg", gp: flagURL+"guadeloupe-flag.svg" };
                                const flagSrc = unKnownFlags[country.iso.toLowerCase()] || ("https://hatscripts.github.io/circle-flags/flags/" + country.iso.toLowerCase() + ".svg");
                                const groupByTags = groupBy( country.types , 'origin');
                                return (
                                    <div className="country" key={j}>
                                        <div className="sticky row no-gutters">
                                            <div className="country-name col-12 col-xs-7"><img className="flag" src={flagSrc} alt={country.country} style={{ height: 24 }} />{country.country}<span className="country-code">{country.dial}</span></div>
                                            <div className="col"></div>
                                        </div>  
                                        {makeCallsLoopUsingTags( groupByTags )}
                                    </div>
                                )
                            })}
                        </div>
                    </div>
                {Object.values(groupedCountries).map((group, i) => {
                    return (
                        <React.Fragment>    
                            <div className='anchor ' id={"country-" + group.index}></div>

                            <div className="group"  key={i}>
                                {group.countries.map((country, j) => {
                                    const unKnownFlags = {wf: flagURL+"wallis-and-futuna-flag.svg", pm: flagURL+"saint-pierre-and-miquelon-flag.svg", yt: flagURL+"mayotte-flag.svg", nc: flagURL+"new-caledonia-flag.svg", gs: flagURL+"south-korea-flag.svg", gp: flagURL+"guadeloupe-flag.svg" };
                                    const flagSrc = unKnownFlags[country.iso.toLowerCase()] || ("https://hatscripts.github.io/circle-flags/flags/" + country.iso.toLowerCase() + ".svg");
                                    const groupByTags = groupBy( country.types , 'origin');
                                    return (
                                        <div className={"country country-anchor-"+group.index} key={j}>
                                            <div className="sticky row no-gutters">
                                                <div className="country-name col-12 col-xs-7"><img className="flag" src={flagSrc} alt={country.country} style={{ height: 24 }} />{country.country}<span className="country-code">{country.dial}</span></div>
                                                <div className="col"></div>
                                            </div>  
                                            {makeCallsLoopUsingTags( groupByTags )}
                                        </div>
                                    )
                                })}
                            </div>
                        </React.Fragment>
                    )
                })}
                {/* {noteMessageFlag && (
                    <div>
                        <div className="note mt-4 font-14 na">* Rates beyond Fair Usage voice will charged at $0.0120 and messages charged at $0.0200</div>
                    </div>
                )} */}
            </div>
        </div>
    )
}

const sendMsgPricingTable = () => {
    const [searchTerm, setSearchTerm] = React.useState('');
    noteMessageFlag = false;

    // Fire after and before component mounts
    React.useEffect(() => {
        document.querySelectorAll('.country').forEach(i => obs.observe(i));
        return () => document.querySelectorAll('.country').forEach(i => obs.unobserve(i));
    })

    // Group countries based on Starting letters
    const groupedCountries = sendMsgPricingData.filter(i => i.country.toLowerCase().indexOf(searchTerm.toLowerCase().trim()) !== -1).reduce((acc, currentItem) => {
        let index = currentItem.country[0];
        if (!acc[index]) acc[index] = { index, countries: [currentItem] }
        else acc[index].countries.push(currentItem);
        var sorted = Object.keys(acc)
        .sort()
        .reduce(function (sorted_acc, key) { 
            sorted_acc[key] = acc[key];
            return sorted_acc;
        }, {});
        return sorted;
    }, {});

    var priorityCountries, priorityCountriesNew = [];
    let countriesToShiftOnTop = ['United States', 'Canada', 'United Kingdom', 'Australia', 'India','France'];

    {Object.values(groupedCountries).map((group, i) => {
        var allCountries = [...group.countries];
        priorityCountries = allCountries.filter(i => countriesToShiftOnTop.includes(i.country));
        Array.prototype.push.apply(priorityCountriesNew, priorityCountries);
    })};

    var result = []

    countriesToShiftOnTop.forEach(function(key) {
        var found = false;
        priorityCountriesNew = priorityCountriesNew.filter(function(item) {
            if(!found && item.country == key) {
                result.push(item);
                found = true;
                return false;
            } else 
                return true;
        })
    })


    priorityCountriesNew = [...result];

    const flagURL = "/assets/images/flags/";

    return (
            <div className="pricing-table show-with-delay">
                <Filter searchTerm={searchTerm} setSearchTerm={setSearchTerm} groupedCountries={groupedCountries}></Filter>
                <div className="pricing-content pt-3">
                    <div className="row no-gutters px-0 header">
                        <h4 className="col-6 col-xs-7 font-weight-bold"></h4>
                        <h4 className="col font-weight-bold">Send Messages<br/><span>(USD per message) </span></h4>
                    </div>
                    <div>
                        <div className="group" >
                            {priorityCountriesNew.map((country, j) => {
                                const unKnownFlags = {wf: flagURL+"wallis-and-futuna-flag.svg", pm: flagURL+"saint-pierre-and-miquelon-flag.svg", yt: flagURL+"mayotte-flag.svg", nc: flagURL+"new-caledonia-flag.svg", gs: flagURL+"south-korea-flag.svg", gp: flagURL+"guadeloupe-flag.svg" };
                                const flagSrc = unKnownFlags[country.iso.toLowerCase()] || ("https://hatscripts.github.io/circle-flags/flags/" + country.iso.toLowerCase() + ".svg");
                                const groupByTags = groupBy( country.types , 'origin');
                                return (
                                    <div className="country" key={j}>
                                            <div className="sticky row no-gutters">
                                                <div className="country-name col-12 col-xs-7"><img className="flag" src={flagSrc} alt={country.country} style={{ height: 24 }} />{country.country}<span className="country-code">{country.dial}</span></div>
                                                <div className="col"></div>
                                            </div>  
                                        {sendMsgLoopUsingTags(groupByTags)}
                                        </div>
                                )
                            })}
                        </div>
                    </div>
                {Object.values(groupedCountries).map((group, i) => {
                    return (
                        <React.Fragment>
                            <div className='anchor ' id={"country-" + group.index}></div>

                            <div className="group"  key={i}>
                                {group.countries.map((country, j) => {
                                    const unKnownFlags = {wf: flagURL+"wallis-and-futuna-flag.svg", pm: flagURL+"saint-pierre-and-miquelon-flag.svg", yt: flagURL+"mayotte-flag.svg", nc: flagURL+"new-caledonia-flag.svg", gs: flagURL+"south-korea-flag.svg", gp: flagURL+"guadeloupe-flag.svg" };
                                    const flagSrc = unKnownFlags[country.iso.toLowerCase()] || ("https://hatscripts.github.io/circle-flags/flags/" + country.iso.toLowerCase() + ".svg");
                                    const groupByTags = groupBy( country.types , 'origin');
                                    return (
                                        <div className={"country country-anchor-"+group.index}  key={j}>
                                            <div className="sticky row no-gutters">
                                                <div className="country-name col-12 col-xs-7"><img className="flag" src={flagSrc} alt={country.country} style={{ height: 24 }} />{country.country}<span className="country-code">{country.dial}</span></div>
                                                <div className="col"></div>
                                            </div>  
                                            
                                            {sendMsgLoopUsingTags( groupByTags )}
                                        </div>
                                    )
                                })}
                            </div>
                        </React.Fragment>
                    )
                })}
                {/* {noteMessageFlag && (
                    <div>
                        <div className="note mt-4 font-14 na">* Rates beyond Fair Usage voice will charged at $0.0120 and messages charged at $0.0200</div>
                    </div>
                )} */}
            </div>
        </div>
    )
}



$(document).on("data.loader", init);

function init() {
    window.pricingData = window.spreadSheetData;
    window.makeCallsPricingData = window.makeCallsSpreadSheetData;
    window.sendMsgPricingData = window.sendMsgSpreadSheetData;
    window.whatsappPricingData = window.whatsappSpreadSheetData;


    $('.loader-container').css('display', 'none');

    const domContainer = document.querySelector('#pricing-container');
    ReactDOM.render(e(PricingTable), domContainer);

    const makeCallsDomContainer = document.querySelector('#make-calls-pricing-container');
    ReactDOM.render(e(makeCallsPricingTable), makeCallsDomContainer);

    const sendMsgDomContainer = document.querySelector('#send-msgs-pricing-container');
    ReactDOM.render(e(sendMsgPricingTable), sendMsgDomContainer);


    const recMsgDomContainer = document.querySelector('#rec-msgs-pricing-container');
    ReactDOM.render(e(PricingTable), recMsgDomContainer);

    const whatsappDomContainer = document.querySelector('#whatsapp-pricing-container');
    ReactDOM.render(e(WhatsappPricingTable), whatsappDomContainer);



    document.querySelectorAll('a[href^="#"]').forEach(function (item) {
        item.addEventListener("click", function (event) {
            event.preventDefault();
            scrollToTargetAdjusted(document.querySelector(item.getAttribute("href")));
        });
    });
}
